from vbyscan import cores


def run(req, target, info_cb, found_cb, not_found_cb):
    # https://github.com/OWASP/vbscan/blob/master/exploit/tapatalk.pl
    name = "Tapatalk SQL Injection"
    uri = f"{target}arcade.php?act=Arcade&do=stats&comment=a&s_id=1"

    info_cb(f"Checking {name}")
    r = req.get(uri + "mobiquo/mobiquo.php")

    if r.status_code == 200 and ("Forum XMLRPC Interface for Tapatalk Application" in r.text or
                                 "Current Tapatalk plugin version" in r.text):
        def parse_version(data):
            regex = r"Current Tapatalk plugin version: (.*?)<br>Latest"
            return cores.parse_regex(data, regex)

        if parse_version(r.text) == "5.2.1":
            import os
            exploit = "/usr/share/exploitdb/exploits/php/webapps/35102.py"
            if not os.path.exists(exploit) or not os.path.isfile(exploit):
                exploit = "https://www.exploit-db.com/exploits/35102"
            found_cb(name, exploit)
            return

    not_found_cb(name)
